unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBTables, DB, Grids, DBGrids, StdCtrls, Gauges,
  ComCtrls, comobj, clipbrd, ExtCtrls, DBCtrls, ToolWin, ActnList, ImgList,
  Mask , IdGlobal, Buttons, DBClient, GWGExporterOOC;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1: TTable;
    StatusBar1: TStatusBar;
    Gauge1: TGauge;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ToolBar1: TToolBar;
    ActionList1: TActionList;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    GoToMsExcel: TAction;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    CheckProperty: TAction;
    ToolButton2: TToolButton;
    StaticText4: TStaticText;
    Edit1: TEdit;
    StaticText5: TStaticText;
    Edit2: TEdit;
    StaticText6: TStaticText;
    Edit3: TEdit;
    SetProperty: TAction;
    ToolButton3: TToolButton;
    SaveDialog1: TSaveDialog;
    SpeedButton1: TSpeedButton;
    Saveastoxls: TAction;
    Edit4: TEdit;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    GWGExporterOOC1: TGWGExporterOOC;
    Settabletoopen: TAction;
    OpenDialog1: TOpenDialog;
    ToolButton4: TToolButton;
    StaticText7: TStaticText;
    Edit5: TEdit;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    ToolButton6: TToolButton;
    Koniec: TAction;
    CheckBox1: TCheckBox;
    StaticText10: TStaticText;
    Edit6: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FindMyButton(Comp: TComponent);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure ComboBox2DropDown(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3DropDown(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure checkprop;
    procedure FormShow(Sender: TObject);
    procedure GoToMsExcelExecute(Sender: TObject);
    procedure CheckPropertyExecute(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure SetPropertyExecute(Sender: TObject);
    procedure SaveastoxlsExecute(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure GWGExporterOOC1Progress(Sender: TObject;
      var Progress: Integer; SendedRows: Integer; m_time: TDateTime);
    procedure SettabletoopenExecute(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure KoniecExecute(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
  private
  blokuj : Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Session.AddPassword('cfjxcut');
  blokuj := False;
  Gauge1.Parent := Form1.StatusBar1;
  Gauge1.SetBounds(2, 4, Form1.StatusBar1.Panels[0].Width-2, Form1.StatusBar1.Height - 5);
end;

procedure TForm1.FindMyButton(Comp: TComponent);
var
  i: integer;
begin
  with Comp do
  begin
    for i:= 0 to ComponentCount-1 do
      if (Components[i] is TPanel) or (Components[i] is TGroupBox) then
       FindMyButton(Components[i])
      else
        if Components[i] is TButton then
         ShowMessage((Components[i] as TButton).Name);
  end;
end;


procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if blokuj = True then exit;
  GWGExporterOOC1.DataSet := FindComponent(ComboBox1.Text) as Tdataset;
  checkprop;
end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
var
  i: integer;
begin
  ComboBox1.Items.Clear;
  with Form1 do
    for i:= 0 to ComponentCount-1 do
       if Components[i] is TDataSet then begin
          ComboBox1.Items.Add((Components[i] as TDataSet).Name);
      end;
      ComboBox1.Items.Add('');
end;

procedure TForm1.ComboBox2DropDown(Sender: TObject);
var
  i: integer;
begin
  ComboBox2.Items.Clear;
  with Form1 do
    for i:= 0 to ComponentCount-1 do
       if Components[i] is TDataSource then begin
          ComboBox2.Items.Add((Components[i] as TDataSource).Name);
      end;
      ComboBox2.Items.Add('');
end;
procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  if blokuj = True then exit;
  GWGExporterOOC1.DataSource :=    FindComponent(ComboBox2.Text) as Tdatasource;
  checkprop;
end;

procedure TForm1.ComboBox3DropDown(Sender: TObject);
var
  i: integer;
begin
  ComboBox3.Items.Clear;
  with Form1 do
    for i:= 0 to ComponentCount-1 do
       if Components[i] is TDBGrid then begin
          ComboBox3.Items.Add((Components[i] as TDBGrid).Name);
      end;
      ComboBox3.Items.Add('');
end;
procedure TForm1.ComboBox3Change(Sender: TObject);
begin
  if blokuj = True then exit;
  GWGExporterOOC1.DBGrid :=    FindComponent(ComboBox3.Text) as TDBGrid;
  checkprop;
end;

procedure TForm1.checkprop;
begin
  blokuj := True; //zablokuj onchange

  if GWGExporterOOC1.DBGrid = nil
    then ComboBox3.Text := ''
    else ComboBox3.Text := GWGExporterOOC1.DBGrid.Name ;

  if GWGExporterOOC1.DataSet = nil
    then ComboBox1.Text := ''
    else ComboBox1.Text := GWGExporterOOC1.DataSet.Name ;

  if GWGExporterOOC1.DataSource = nil
    then ComboBox2.Text := ''
  else ComboBox2.Text := GWGExporterOOC1.DataSource.Name ;

  Edit1.Text := IntToStr(GWGExporterOOC1.FirstRowsToSend);
  Edit2.Text := IntToStr(GWGExporterOOC1.LastRowsToSend);
  Edit3.Text := IntToStr(GWGExporterOOC1.RowsToSend);
  Edit5.Text :=IntToStr(GWGExporterOOC1.EXportFormat);
  Edit5.Text :=IntToStr(GWGExporterOOC1.EXportFormat);
  Edit6.Text :=GWGExporterOOC1.IniFile;

  CheckBox1.Checked := GWGExporterOOC1.CopyToNewCalc;
  CheckBox2.Checked := GWGExporterOOC1.VisibleAfterExport;
  CheckBox3.Checked := GWGExporterOOC1.SaveAfterExport;
  StaticText9.Caption := GWGExporterOOC1.SaveFormat;
  Edit4.Text := GWGExporterOOC1.FileToSave;
  blokuj := False; //UNlock event onchange

end;

procedure TForm1.FormShow(Sender: TObject);
begin
  checkprop;
end;

procedure TForm1.GoToMsExcelExecute(Sender: TObject);
begin
  GoToMsExcel.Enabled := False;
  Gauge1.MinValue := 0;
  Gauge1.Progress :=0;
  Gauge1.MaxValue := 100;
  DBGrid1.Hide;

  SetProperty.Enabled:=False;
  try
  GWGExporterOOC1.GoToSCalc;
  except
  SetProperty.Enabled:=True;
  Gauge1.Hide;
  DBGrid1.Show;

  GoToMsExcel.Enabled := True;
  //ShowMessage('Error...');
  end;
  SetProperty.Enabled:=True;
  Gauge1.Hide;
  DBGrid1.Show;

  GoToMsExcel.Enabled := True;
//  GWGExporterOOC1.setDefaultProperty;
  checkprop ;
end;

procedure TForm1.CheckPropertyExecute(Sender: TObject);
begin
 checkprop;
end;

procedure TForm1.Edit1Change(Sender: TObject);
var
  dana : ShortString;
  i : SmallInt;
  checknum : Boolean;
begin
  if blokuj = True then exit;
  blokuj := True;
  dana := trim(Edit1.Text);
  if Length(dana) = 0 then
  begin
   blokuj := False;
   exit;
  end;
  checknum := True;
  for i := 1 to length(dana) do
    if not IsNumeric(dana[i]) then checknum := False;
    if checknum then
    GWGExporterOOC1.FirstRowsToSend := StrToInt(dana);
  checkprop;
  Edit1.SelStart := Length(edit1.Text);
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
  checkprop;
end;

procedure TForm1.Edit2Change(Sender: TObject);
var
  dana : ShortString;
  i : SmallInt;
  checknum : Boolean;
begin
  if blokuj = True then exit;
  blokuj := True;
  dana := trim(Edit2.Text);
  if Length(dana) = 0 then
  begin
   blokuj := False;
   exit;
  end;
  checknum := True;
  for i := 1 to length(dana) do
    if not IsNumeric(dana[i]) then checknum := False;
    if checknum then
    GWGExporterOOC1.LastRowsToSend := StrToInt(dana);
  checkprop;
  Edit2.SelStart := Length(edit2.Text);
end;

procedure TForm1.Edit3Change(Sender: TObject);
var
  dana : ShortString;
  i : SmallInt;
  checknum : Boolean;
begin
  if blokuj = True then exit;
  blokuj := True;
  dana := trim(Edit3.Text);
  if Length(dana) = 0 then
  begin
   blokuj := False;
   exit;
  end;
  checknum := True;
  for i := 1 to length(dana) do
    if not IsNumeric(dana[i]) then checknum := False;
    if checknum then
    GWGExporterOOC1.RowsToSend := StrToInt(dana);
  checkprop;
  Edit3.SelStart := Length(edit3.Text);
end;
procedure TForm1.FormPaint(Sender: TObject);
begin
//checkprop;
end;

procedure TForm1.FormDeactivate(Sender: TObject);
begin
  checkprop;
end;

procedure TForm1.SetPropertyExecute(Sender: TObject);
begin
  GWGExporterOOC1.setDefaultProperty;
  Edit6.Text:='';
  checkprop;
end;

procedure TForm1.SaveastoxlsExecute(Sender: TObject);
begin
  SaveDialog1.Filter:='MsExcel Files (*.xls)|*.xls';
  SaveDialog1.DefaultExt:='xls';
  Savedialog1.FileName:= 'Export.xls';
  Savedialog1.Title:= 'Save as MsExcel files';
  SaveDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  if SaveDialog1.Execute then
  begin
    GWGExporterOOC1.FileToSave:=SaveDialog1.FileName;
    checkprop;
  end ;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  GWGExporterOOC1.VisibleAfterExport := CheckBox2.Checked;
  checkprop;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  GWGExporterOOC1.SaveAfterExport := CheckBox3.Checked;
  checkprop;
end;

procedure TForm1.GWGExporterOOC1Progress(Sender: TObject;
  var Progress: Integer; SendedRows: Integer; m_time: TDateTime);
begin
  Gauge1.Progress := Progress;
  Gauge1.Show;
  if Progress = 100 then Gauge1.Hide;
  StatusBar1.Panels[1].Text := 'Sended Rows : ' + IntToStr(SendedRows)
    + ' in... ' + FormatDateTime('nn:ss.zzz',m_time);
end;

procedure TForm1.SettabletoopenExecute(Sender: TObject);
begin
  Table1.Close;
  OpenDialog1.Filter:='Paradox and DBase Tables (*.DBF;*.DB)|*.DBF;*.DB';
  if not OpenDialog1.Execute then exit;
  Table1.Close;
  Table1.TableName := OpenDialog1.FileName;
  Table1.Open;
end;

procedure TForm1.Edit5Change(Sender: TObject);
var
  dana : ShortString;
  i : SmallInt;
  checknum : Boolean;
begin
  if blokuj = True then exit;
  blokuj := True;
  dana := trim(Edit5.Text);
  if Length(dana) = 0 then
  begin
   blokuj := False;
   exit;
  end;
  checknum := True;
  for i := 1 to length(dana) do
    if not IsNumeric(dana[i]) then checknum := False;
    if checknum then
    GWGExporterOOC1.EXportFormat := StrToInt(dana);
  checkprop;
  Edit5.SelStart := Length(edit5.Text);
end;
procedure TForm1.KoniecExecute(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  GWGExporterOOC1.CopyToNewCalc := CheckBox1.Checked;
  checkprop;
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
  GWGExporterOOC1.IniFile := Edit6.Text;
  checkprop;
end;

end.
